var pi, mc, h, y, A, theta, w, n, u, v, c, mw, gap, i;
predetermined_variables n;
varexo e_A, e_m; 

parameters kappa, beta, eta, sigma, rho, psi, phi_pi, phi_y, chi, wstat, mwstat, hstat, ystat, s, x_h, Astat, epsilon, zeta, ustat, m0, alpha, vstat, thetastat, nstat, rho_A, mcstat, cstat, b, gapstat;
kappa=0.0042;
beta=0.99^(1/3);
eta=2;
sigma=1;
rho=0.8^(1/3);
phi_pi=1.5;
phi_y=0.5/12;
chi=0.082; 
hstat=1; 
wstat=0.825;
mwstat=1/1.2;
ystat=0.94; 
Astat=1;
cstat=0.933; 
thetastat=1.424;
alpha=0.99;
m0=0.38;
s=0.03;
epsilon=0.6;
zeta=0.5;
ustat=0.06;
nstat=0.94;
vstat=0.085;
rho_A=0.95^(1/3);
mcstat=1/1.2;
b=0.425; 
x_h=0.884; 
psi = 0.4;
gapstat=(1/alpha)*mwstat-wstat;

model (linear);
theta=v-u;
ustat*u=-nstat*n;
pi=kappa*mc+beta*(pi(+1));
mc=mw-A-(alpha-1)*h;
y=(cstat/ystat)*c+(chi*vstat/ystat)*v;
c=c(+1)-(i-pi(+1));
(chi/(m0*thetastat^(epsilon-1)))*(1-epsilon)*theta=beta*(mcstat*Astat*hstat^(alpha)*(mc(+1)+A(+1)+alpha*h(+1)+c-c(+1))-(w(+1)+h(+1)+c-c(+1))*(wstat*hstat)+(1-s)*(chi/(m0*thetastat^(epsilon-1)))*((1-epsilon)*theta(+1)+c-c(+1)));
y=A+n+alpha*h;
w=((1-psi)*zeta*mcstat*Astat*hstat^(alpha-1)*(mc+A+(alpha-1)*h)+(1-psi)*(zeta*chi*thetastat/hstat)*(theta-h)-(1-psi)*((1-zeta)*b*h/hstat)+(1-psi)*x_h*((1-zeta)/(1+eta))*cstat*(hstat^(eta))*(eta*h+c))*(1/wstat);
n(+1)=(1-s)*n+s*(epsilon*v+(1-epsilon)*u);
i=rho*i(-1)+(1-rho)*(phi_pi*pi+phi_y*y)+e_m;
A=rho_A*A(-1)+e_A;
mw=((((1-psi)*(1-zeta))/(1-(1-psi)*zeta))*(x_h*hstat^(eta)*cstat)*(eta*h+c))*(1/mwstat);
gap=((1/alpha)*mwstat*mw-wstat*w)/gapstat;
end;

initval;
c=0;
pi=0;
mc=0;
h=0;
y=0;
A=0;
w=0;
i=0;
theta=0;
n=0;
u=0;
v=0;
e_A=0;
e_m=0;
mw=0;
gap=0;
end;

steady;
check;

shocks;
var e_A;
stderr 0.00; 
var e_m;
stderr 0.00;    
end;

stoch_simul(nofunctions, order=1, nograph);
