format long

dynare rtm_cb

A = oo_.dr.ghx;
B = oo_.dr.ghu;

% Put the steady-state values of endogenous variables in DR-order

for i=1:size(oo_.dr.ys,1) 
SS(oo_.dr.inv_order_var(i),1) = oo_.dr.ys(i);
end

% Initialize the state in DR-order 

state1 = [0 0 0]';
simul1 = zeros(14,816);


for j=1:200;
    
  % r = productivity shocks; m = monetary shocks  
  r = 0.009*randn(816,1);
  m = 0.00058*randn(816,1);

   for i=1:816
        
      shocks = [r(i) m(i)]';
      simul1(:,i)= SS + A*state1 + B*shocks;
      %Update state
      state1 = [simul1(6,i) simul1(7,i) simul1(8,i)]'; 
            
    end
      
    simul1(:,[1:90])=[];
    
    y_monthly(:,j)=simul1(1,:)';
    u_monthly(:,j)=simul1(2,:)';
    v_monthly(:,j)=simul1(3,:)';
    c_monthly(:,j)=simul1(14,:)';
    i_monthly(:,j)=simul1(7,:)';
    n_monthly(:,j)=simul1(6,:)';
    A_monthly(:,j)=simul1(8,:)';
    pi_monthly(:,j)=simul1(9,:)';
    mc_monthly(:,j)=simul1(10,:)';
    h_monthly(:,j)=simul1(11,:)';
    theta_monthly(:,j)=simul1(12,:)';
    w_monthly(:,j)=simul1(13,:)';
    mw_monthly(:,j)=simul1(4,:)';
    gap_monthly(:,j)=simul1(5,:)';
   
    % Reset r, simul and state
   
    r = zeros(816,1);
    m = zeros(816,1);
    simul1 = zeros(14,816);
    state1 = [0 0 0]';
    
    for k=1:723/3
        y_quarterly(k,j) = (y_monthly(3*(k-1)+1,j)+y_monthly(3*(k-1)+2,j)+y_monthly(3*(k-1)+3,j))/3;
        u_quarterly(k,j) = (u_monthly(3*(k-1)+1,j)+u_monthly(3*(k-1)+2,j)+u_monthly(3*(k-1)+3,j))/3;
        v_quarterly(k,j) = (v_monthly(3*(k-1)+1,j)+v_monthly(3*(k-1)+2,j)+v_monthly(3*(k-1)+3,j))/3;
        c_quarterly(k,j) = (c_monthly(3*(k-1)+1,j)+c_monthly(3*(k-1)+2,j)+c_monthly(3*(k-1)+3,j))/3;
        i_quarterly(k,j) = (i_monthly(3*(k-1)+1,j)+i_monthly(3*(k-1)+2,j)+i_monthly(3*(k-1)+3,j))/3;
        n_quarterly(k,j) = (n_monthly(3*(k-1)+1,j)+n_monthly(3*(k-1)+2,j)+n_monthly(3*(k-1)+3,j))/3;
        A_quarterly(k,j) = (A_monthly(3*(k-1)+1,j)+A_monthly(3*(k-1)+2,j)+A_monthly(3*(k-1)+3,j))/3;
        pi_quarterly(k,j) = (pi_monthly(3*(k-1)+1,j)+pi_monthly(3*(k-1)+2,j)+pi_monthly(3*(k-1)+3,j));
        mc_quarterly(k,j) = (mc_monthly(3*(k-1)+1,j)+mc_monthly(3*(k-1)+2,j)+mc_monthly(3*(k-1)+3,j))/3;
        h_quarterly(k,j) = (h_monthly(3*(k-1)+1,j)+h_monthly(3*(k-1)+2,j)+h_monthly(3*(k-1)+3,j))/3;
        theta_quarterly(k,j) = (theta_monthly(3*(k-1)+1,j)+theta_monthly(3*(k-1)+2,j)+theta_monthly(3*(k-1)+3,j))/3;
        w_quarterly(k,j) = (w_monthly(3*(k-1)+1,j)+w_monthly(3*(k-1)+2,j)+w_monthly(3*(k-1)+3,j))/3;
        mw_quarterly(k,j) = (mw_monthly(3*(k-1)+1,j)+mw_monthly(3*(k-1)+2,j)+mw_monthly(3*(k-1)+3,j))/3;
        gap_quarterly(k,j) = (gap_monthly(3*(k-1)+1,j)+gap_monthly(3*(k-1)+2,j)+gap_monthly(3*(k-1)+3,j))/3;
    end
end
  
% % HP filter the series with weight = 1600 and compute standard deviations
 
weight = 1600;
for l=1:200
     
    [trend_y(:,l)]= hpfilter(y_quarterly(:,l),weight);
     y(:,l)=y_quarterly(:,l)-trend_y(:,l);
    [trend_u(:,l)]= hpfilter(u_quarterly(:,l),weight);
     u(:,l)=u_quarterly(:,l)-trend_u(:,l);
    [trend_v(:,l)]= hpfilter(v_quarterly(:,l),weight);
     v(:,l)=v_quarterly(:,l)-trend_v(:,l); 
    [trend_c(:,l)]= hpfilter(c_quarterly(:,l),weight);
     c(:,l)=c_quarterly(:,l)-trend_c(:,l);
    [trend_i_nominal(:,l)]= hpfilter(i_quarterly(:,l),weight);
     i_nominal(:,l)=i_quarterly(:,l)-trend_i_nominal(:,l);
    [trend_n(:,l)]= hpfilter(n_quarterly(:,l),weight);
     n(:,l)=n_quarterly(:,l)-trend_n(:,l);
    [trend_pi(:,l)]= hpfilter(pi_quarterly(:,l),weight);
     pi(:,l)=pi_quarterly(:,l)-trend_pi(:,l);
    [trend_h(:,l)]= hpfilter(h_quarterly(:,l),weight);
     h(:,l)=h_quarterly(:,l)-trend_h(:,l);
    [trend_theta(:,l)]= hpfilter(theta_quarterly(:,l),weight);
     theta(:,l)=theta_quarterly(:,l)-trend_theta(:,l);
    [trend_w(:,l)]= hpfilter(w_quarterly(:,l),weight);
     w(:,l)=w_quarterly(:,l)-trend_w(:,l);
    [trend_mw(:,l)]= hpfilter(mw_quarterly(:,l),weight);
     mw(:,l)=mw_quarterly(:,l)-trend_mw(:,l);
    [trend_gap(:,l)]= hpfilter(gap_quarterly(:,l),weight);
     gap(:,l)=gap_quarterly(:,l)-trend_gap(:,l);
     
   
   % Compute standard deviations in each sample
   
   sdy(:,l) = std(y(:,l));
   sdu(:,l) = std(u(:,l));
   sdv(:,l) = std(v(:,l));
   sdc(:,l) = std(c(:,l));
   sdi(:,l) = std(i_nominal(:,l));
   sdn(:,l) = std(n(:,l));
   sdpi(:,l) = std(pi(:,l));
   sdh(:,l) = std(h(:,l));
   sdtheta(:,l) = std(theta(:,l));
   sdw(:,l) = std(w(:,l));
   sdmw(:,l) = std(mw(:,l));
   sdgap(:,l) = std(gap(:,l));
   
    
end

sd_y = mean(sdy)
sd_u_y = mean(sdu)/mean(sdy)
sd_v_y = mean(sdv)/mean(sdy)
sd_theta_y = mean(sdtheta)/mean(sdy)
sd_h_y = mean(sdh)/mean(sdy)
sd_w_y = mean(sdw)/mean(sdy)
elasticity_mw = mean(sdmw)/mean(sdh)
sd_pi_y = mean(sdpi)/mean(sdy)